<template>
  <div class="container bg-white">
    <div class="row">
      <div class="col-md-12 upload-container" v-show="showUpload">
        <vue-dropzone
          ref="myVueDropzone"
          id="dropzone dropzoneCustom"
          :options="dropzoneOptions"
          :useCustomSlot="true"
          :duplicateCheck="true"
          @vdropzone-removed-file="vremoved"
          @vdropzone-file-added="vadded"
        >
          <div class="dropzone-custom-content">
            <img
              :src="asset('images/icons/upload-icon.png')"
              style="width:50px"
              class="text-center"
            >
            
            <b class="text-primary d-block">Drag and drop to upload content</b>
            <small class="text-muted">or click to select a file from your computer</small>
          </div>
        </vue-dropzone>
      </div>
      <div class="col-md-12">
        <div class="bottom" :class="{'justify-content-center':showUpload}">
          <form class="position-relative w-100" @submit.prevent="sendText" v-show="!showUpload">
            <div class="input-group">
              <button
                class="btn bg-light input-group-prepend"
                :disabled="!isLive"
                type="button"
                @click="showEmojiPicker = !showEmojiPicker"
              >
                <span class="input-group-text bg-none">
                  <i class="material-icons">insert_emoticon</i>
                </span>
              </button>
              <div
                v-show="showEmojiPicker"
                style="position:absolute;bottom:75px"
                aria-labelledby="dropdownMenuButton"
              >
                <picker
                  set="apple"
                  :showPreview="false"
                  :sheetSize="16"
                  :include="['people']"
                  @select="selectEmoji"
                />
              </div>
              <textarea
                class="form-control bg-light"
                name="message"
                v-validate="'required'"
                placeholder="Start typing for reply..."
                rows="1"
                style="overflow:hidden"
                v-model="inputMessage"
                @keypress.enter.prevent="sendText"
                :disabled="!isLive"
              ></textarea>
              <button
                :disabled="!isLive"
                class="btn bg-light input-group-prepend mic-container"
                type="button"
                @click="listeningVoice"
              >
                <span class="input-group-text bg-none" v-show="isListening" style="z-index:999">
                  <i class="material-icons text-primary">mic_none</i>
                </span>
                <span class="input-group-text bg-none" v-show="!isListening">
                  <i class="material-icons text-primary">mic</i>
                </span>
                <img
                  :src="asset('images/misc/listen.gif')"
                  alt
                  class="listen-gif"
                  v-show="isListening"
                >
              </button>
              <button :disabled="!isLive" class="btn bg-light input-group-prepend" type="submit">
                <span class="input-group-text bg-none">
                  <i class="material-icons text-primary">send</i>
                </span>
              </button>
            </div>
          </form>
          <label @click="openShowUpload" v-show="!showUpload">
            <span class="btn attach d-sm-block d-none">
              <i class="material-icons">attach_file</i>
            </span>
          </label>
          <label v-show="showUpload" @click="sendFile">
            <span class="btn attach d-sm-block d-none">
              <i class="material-icons">send</i>
            </span>
          </label>
          <label @click="closeShowUpload" v-show="showUpload">
            <span class="btn attach d-sm-block d-none">
              <i class="material-icons">close</i>
            </span>
          </label>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import chatMixin from "@/mixins/ChatMixin";
import liveChatMixin from "@/mixins/LiveChatMixin";
import vue2Dropzone from "vue2-dropzone";
import "vue2-dropzone/dist/vue2Dropzone.min.css";
import moment from "moment";
import { Picker } from "emoji-mart-vue";

if (navigator.userAgent.indexOf("Firefox") == -1) {
  var speech = new (window.SpeechRecognition ||
    window.webkitSpeechRecognition)();
  speech.lang = "id-ID";
  speech.interimResults = true;
  speech.continuous = true;
  speech.maxAlternatives = 1;
}

export default {
  mixins: [chatMixin, liveChatMixin],
  components: {
    vueDropzone: vue2Dropzone,
    Picker: Picker
  },
  computed: {
    isLive() {
      if (this.selectedRoom == null) {
        return false;
      }
      // return true
      return (
        this.selectedRoom.livechat != null &&
        this.selectedRoom.livechat.status == "live"
      );
    }
  },
  data: function() {
    return {
      dropzoneOptions: {
        url:
          process.env.MIX_APP_URL +
          `/api/${this.$store.getters.appId.hashed}/chat/upload-file`,
        thumbnailWidth: 150,
        thumbnailHeight: 200,
        addRemoveLinks: true,
        maxFilesize: 0.5,
        clickable: true,

        headers: {
          userId: JSON.parse(localStorage.getItem("user")).id,
          token: JSON.parse(localStorage.getItem("user")).token.access_token
        },
        renameFile: function(file) {
          return moment().format("x") + "-" + file.name;
        }
      },
      inputMessage: "",
      showUpload: false,
      isResetDropzone: false,
      uploadedFiles: [],
      isListening: false,
      showEmojiPicker: false
    };
  },
  watch: {
    isListening() {
      if (this.isListening) {
        speech.start();
      } else {
        speech.stop();
      }
    }
  },
  methods: {
    async vremoved(file, error, xhr) {
      if (!this.isResetDropzone) {
        let response = await this.$axiosNoLoading.post(
          `api/${this.$store.getters.appId.hashed}/chat/delete-file`,
          {
            fileToDelete: file.upload.filename
          }
        );
        let fileIndex = _.findIndex(this.uploadedFiles, function(obj) {
          return obj.name == file.upload.filename;
        });
        this.uploadedFiles.splice(fileIndex, 1);
      }
    },
    vadded(file) {
      let type;
      switch (file.type.split("/")[0]) {
        case "image":
          type = "image";
          break;

        default:
          type = "file";
          break;
      }
      let fileToPush = {
        fileName: file.upload.filename,
        fileType: type
      };
      this.uploadedFiles.push(fileToPush);
    },
    openShowUpload() {
      if (!this.isLive) {
        return false;
      }
      this.showUpload = true;
    },
    closeShowUpload() {
      this.clearDropzone();
      this.$refs.myVueDropzone.removeAllFiles(true);
    },
    sendFile() {
      if (this.uploadedFiles.length != 0) {
        for (const value of this.uploadedFiles) {
          let data = {
            message: {
              fileName: value.fileName,
              type: value.fileType
            }
          };
          this.sendMessage(data);
        }
      }
      this.isResetDropzone = true;
      this.$refs.myVueDropzone.removeAllFiles(true);
      this.clearDropzone();
    },
    clearDropzone() {
      this.uploadedFiles = [];
      this.isResetDropzone = false;
      this.showUpload = false;
    },
    listeningVoice() {
      this.isListening = !this.isListening;
      let finalText;
      if (this.isListening) {
        speech.onresult = event => {
          // console.log("You said: ", event.results);
          this.inputMessage = event.results[0][0].transcript;
          // console.log(event.results)
          if (event.results[0].isFinal) {
            this.isListening = false;

            this.sendText();
          }
        };
      }
    },
    selectEmoji(emoji) {
      this.inputMessage += emoji.native;
    },
    sendText() {
      if (this.inputMessage == "") {
        return;
      }
      let data = {
        message: {
          text: this.inputMessage,
          type: "text"
        }
      };
      this.sendMessage(data);
    },
    sendMessage(data) {
      this.$store.dispatch("chat/sendMessage", {
        room: this.selectedRoom,
        senderId: this.$store.getters.localStorage.decodedUserId,
        senderType: "user_platform",
        message: data.message,
        vm: this
      });
      this.inputMessage = "";
    }
  }
};
</script>

<style lang="scss" scoped>
.mic-container {
  position: relative;
}
.listen-gif {
  position: absolute;
  top: 0;
}
.bottom {
  padding: 10px !important;
}
.chat-input-container {
  position: fixed;
  bottom: 0px;
  z-index: 100;
  background: white;
}
.container {
  position: relative;
}
.upload-container {
  position: absolute;
  bottom: 75px;
  left: 0;
  z-index: 999;
}

.vue-dropzone {
  max-height: 80vh;
  overflow-y: scroll;
}

.dropzone .dz-preview {
  width: 10px !important;
}
</style>
